%clear;
path(path, '../../../Sub');

w0 = 2*pi * 2.2e9;          %  
c = 299792458.0;            %  

wd = 2*pi * 35e6;           %  
Td = 2*pi / wd;

T = 1e-3;                   %   
N = 40+3552+14;             %   

Nd = fix(T/Td);             %    

q = 10^(34/10);             %       

Tpn = 1e-3/4095;
DP = [pi; 2*pi*1; 14];      %       
DT = [23; 0.14; 5];         %       
t = T * (0:N-1);            %  

x = sat(t, 1, 11);          %    
x = DiffCalc(x, t, 4);      %   
xp = x(1:3, :) /c*w0;       %  ,    
xt = x(1:3, :);             %  ,   
F = [1 T 0;                 %  
     0 1 T;
     0 0 1];
G = [0; 0; T];
Cp = [1 0 0];
%Dep = (w0/c)^2 * 2/2.2e4 * 4;
Dep = (w0/c)^2 * 2/1e2 * 4;
xp0 = zeros(3, N);          %    
xp0(:, 1) = xp(:, 1) + (DP .* (-1 + 2*rand(3, 1)));
xt0 = zeros(3, N);          %    
xt0(:, 1) = xt(:, 1) + (DT .* (-1 + 2*rand(3, 1)));
Dp = zeros(3, 3, N);
Kp = zeros(3, 1, N);

Dp(:, :, 1) = diag([20/180*pi; 2*pi*1; 1.9/c*w0].^2/3);
Dnp = 1/2/q/T * (1 + 1/2/q/T);
%Det = 2/2.2e4*4;
Det = 2/1e2*4;
Dt  = zeros(3, 3, N);
Dte = zeros(3, 3, N);
Kt  = zeros(3, 2, N);

Dt(:, :, 1) = diag(DT.^2/12);
Ct = [1 0 0;
      0 1 0];
Dnt = c/5.2e6/q/T * (1 + 1/2/q/T);
SdQ = 2*q*T;
SgnQ = sqrt(2*q*T);

for iN=2:N
  xp0(:, iN) = F * xp0(:, iN-1);  %  
  Dp(:, :, iN) = F * Dp(:, :, iN-1) * F' + G*Dep*G';;
  xt0(:, iN) = F * xt0(:, iN-1);         %  
  Dte(:, :, iN) = F * Dt(:, :, iN-1) * F' + G*Det*G';;

  %  
  mI(iN) =  SdQ * cos(xp(1, iN) - xp0(1, iN) + (xp(2, iN) - xp0(2, iN))*T/2);
  mQ(iN) = -SdQ * sin(xp(1, iN) - xp0(1, iN) + (xp(2, iN) - xp0(2, iN))*T/2);
  mI(iN) = mI(iN) * sin((xp(2, iN) - xp0(2, iN))*T/2)/((xp(2, iN) - xp0(2, iN))*T/2);
  mQ(iN) = mQ(iN) * sin((xp(2, iN) - xp0(2, iN))*T/2)/((xp(2, iN) - xp0(2, iN))*T/2);

  I(iN)  = (1-abs(xt(1, iN)-xt0(1, iN)        )/Tpn/c)*mI(iN) + SgnQ*randn(1,1);
  Q(iN)  = (1-abs(xt(1, iN)-xt0(1, iN)        )/Tpn/c)*mQ(iN) + SgnQ*randn(1,1);
  Ie(iN) = (1-abs(xt(1, iN)-xt0(1, iN)-Tpn/2*c)/Tpn/c)*mI(iN) + SgnQ*randn(1,1);
  Il(iN) = (1-abs(xt(1, iN)-xt0(1, iN)+Tpn/2*c)/Tpn/c)*mI(iN) + SgnQ*randn(1,1);          
  Qe(iN) = (1-abs(xt(1, iN)-xt0(1, iN)-Tpn/2*c)/Tpn/c)*mQ(iN) + SgnQ*randn(1,1);
  Ql(iN) = (1-abs(xt(1, iN)-xt0(1, iN)+Tpn/2*c)/Tpn/c)*mQ(iN) + SgnQ*randn(1,1);          
  
  %Udp = xp(1, iN) - xp0(1, iN);     %  
  %Sdp = 1;

  Udp = -atan(Q(iN)/I(iN));
  Sdp = 1;
  %Udt = xt(1, iN) - xt0(1, iN);
  %Sdt = 1;

  Udt = I(iN) * (Ie(iN) - Il(iN));
  Sdt = 4*q^2*T^2 /Tpn/c;

  Dp(:, :, iN) = (Dp(:, :, iN)^(-1) + Cp' * Dnp^(-1) * Cp)^(-1);
  Kp(:, iN) = Dp(:, :, iN) * Cp' * Dnp^(-1);

  xp0(:, iN) = xp0(:, iN) + Kp(:, 1, iN)/Sdp * Udp;  %  
  yt = [Udt/Sdt; (xp0(2, iN)/w0*c - xt0(2, iN))];
  %Dnyt = [Dnt 0; 0 Dp(2, 2, iN)/w0^2*c^2];
  %Dnyt = [Dnt 0; 0 0.003^2];
  Dnyt = [Dnt 0; 0 sqrt(Dp(2, 2, iN))/w0*c];

  Dt(:, :, iN) = (Dte(:, :, iN)^(-1) + Ct' * Dnyt^(-1) * Ct)^(-1);
  Kt(:, :, iN) = Dt(:, :, iN) * Ct' * Dnyt^(-1);

  %fprintf('%g  %g  %g\n', sqrt(Dp(2,2,iN)/w0^2*c^2), sqrt(Dt(2, 2, iN)), sqrt(Dte(2, 2, iN)));

  xt0(:, iN) = xt0(:, iN) + Kt(:, :, iN) * yt; %  
end

%< >>
